Bug 1045556 - Review Request: hbase - The Apache Hadoop database
Summary: Review Request: hbase - The Apache Hadoop database
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Haïkel Guémar
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: metrics 1049905 1053464 1053489
Blocks: bigdata-review
TreeView+ depends on / blocked
 
Reported: 2013-12-20 17:49 UTC by Robert Rati
Modified: 2014-01-28 12:27 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-01-28 12:27:31 UTC
karlthered: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Robert Rati 2013-12-20 17:49:33 UTC
Spec URL: http://rrati.fedorapeople.org/hbase.spec
SRPM URL: http://rrati.fedorapeople.org/hbase-0.96.0-1.fc19.src.rpm
Description: Apache HBase is a database for Apache Hadoop that provides a distributed, scalable, big data store.
Fedora Account System Username: rrati

Comment 1 Michael S. 2013-12-20 22:04:52 UTC
Need metrics, doesn't build in rawhide yet.

Comment 3 Haïkel Guémar 2014-01-12 21:34:07 UTC
Quick review.

Builds on rawhide (F21), it has missing dependencies on F20 and lower (notably: objectweb-asm3, jamon-maven-plugin) for people who want to try it.


I ran rpmlint (very very long output so i won't put it here) and found:
* 6 errors (script-without-shebang) => it concerns some scripts installed in /usr/share/hbase/bin, the shell ones are clearly libraries, the ruby ones are clearly meant to be called through hbase jruby based shell.
Since guidelines doesn't enforce but highly encourage packager using libexecdir for helper scripts, it's ok for me

hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/replication/copy_tables_desc.rb
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/hbase-config.sh
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/region_mover.rb
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/hirb.rb
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/hbase-common.sh
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/region_status.rb

* 163 warnings: A gazillion of dangling symlinks, i haven't finished reviewing them all but seems safe. At least, there's no bundled libraries

* packaging looks fine, installs ok but needs to be tested under a rawhide VM

Comment 4 Haïkel Guémar 2014-01-13 12:54:47 UTC
I can start HBase using either provided systemd units and upstream scripts but shell fails:

$ hbase shell
ClassLoader.java:-2:in `defineClass1': java.lang.IncompatibleClassChangeError: class org.jruby.compiler.impl.SkinnyMethodAdapter has interface org.objectweb.asm.MethodVisitor as super class
        from ClassLoader.java:800:in `defineClass'
        from SecureClassLoader.java:142:in `defineClass'
        from URLClassLoader.java:449:in `defineClass'
        from URLClassLoader.java:71:in `access$100'
        from URLClassLoader.java:361:in `run'
        from URLClassLoader.java:355:in `run'
        from AccessController.java:-2:in `doPrivileged'
        from URLClassLoader.java:354:in `findClass'
        from ClassLoader.java:425:in `loadClass'
        from Launcher.java:308:in `loadClass'
        from ClassLoader.java:358:in `loadClass'
        from OptoFactory.java:109:in `<clinit>'
        from Ruby.java:4549:in `<init>'
        from Ruby.java:280:in `newInstance'
        from Main.java:262:in `internalRun'
        from Main.java:221:in `run'
        from Main.java:201:in `main'

Comment 5 Robert Rati 2014-01-13 20:12:56 UTC
This is an issue with the classpath and where the shell dependencies lie within it.  I've fixed it and will be posting a new version for review.

Comment 7 Haïkel Guémar 2014-01-13 22:37:28 UTC
Classpath issue has been fixed, the hbase shell is now properly working.

Comment 8 Haïkel Guémar 2014-01-16 15:01:08 UTC
Build broken in rawhide, since last netty build (4.0.14) from 3 days ago, it doesn't provide mvn(io.netty:netty) anymore. An Hadoop rebuild might be required.
Except that, there's no other blocker in the review: packaging is ok, source code ok, works as expected in a single node setup using a pre-netty update build.

Comment 9 Haïkel Guémar 2014-01-16 15:06:07 UTC
Ticket already opened, i added it as dependency to the review.
https://bugzilla.redhat.com/show_bug.cgi?id=1053464

Comment 10 Haïkel Guémar 2014-01-25 20:09:50 UTC
Ok, since it builds now, let's finish this review :o)

I hereby approve of hbase inclusion in Fedora Packages Collections as it complies with Fedora generic
and Java packaging guidelines.
You'll find the formal review below, please now file a scm request.

Here are few comments about the review, with suggestions to the attention of the packager (up to him, to follow them or not)


scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6453466
As expected, still installs and works on a fresh rawhide install.

Please notice that out of curiosity, i made a minor change in the spec used in the scratch build,
i enabled the %check section.
All tests passed, but it seems to take some time (about 20 minutes), so it seems a valid reason to 
disable them.
May i suggest to use a conditional to enable temporarily the test suite ? So one won't need to 
modify the spec by hand to run it.

%bcond_with tests 
(...)
%check
%if %{with tests}
xmvn -Dhadoop.profile=2.0 test
%endif

I won't consider this as a blocker, since it's a SHOULD and it significantly lengthens the build time.

A lot of rpmlint errors and warnings, most of them fall in these categories:
* W: dangling-symlink: harmless, they link to jars provided by dependencies
* E: script-without-shebang: these are helper scripts, they should be in %{_libexecdir} according latest FHS discussions (and GNU guidelines) but fp.o doesn't enforce that.
* the rest is OK


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache (v2.0)".
     154 files have unknown license. Detailed output of licensecheck in
     /home/haikel/1045556-hbase/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /etc/logrotate.d
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 419840 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It is
     pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in hbase-
     javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Files in /run, var/run and /var/lock uses tmpfiles.d when appropriate
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: hbase-0.96.1.1-2.fc21.noarch.rpm
          hbase-javadoc-0.96.1.1-2.fc21.noarch.rpm
          hbase-tests-0.96.1.1-2.fc21.noarch.rpm
          hbase-0.96.1.1-2.fc21.src.rpm
hbase.noarch: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
hbase.noarch: W: only-non-binary-in-usr-lib
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.el-api-3.0.0.jar /usr/share/java/glassfish-el-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.servlet.jsp-2.2.5.jar /usr/share/java/glassfish-jsp/javax.servlet.jsp.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/relaxngDatatype-SYSTEM.jar /usr/share/java/relaxngDatatype.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/avalon-framework-api-4.3.jar /usr/share/java/avalon-framework-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/xmlenc-0.52.jar /usr/share/java/xmlenc.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-compress-1.4.1.jar /usr/share/java/commons-compress.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-mapreduce-client-common-2.2.0.jar /usr/share/java/hadoop/hadoop-mapreduce-client-common.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/guava-12.0.1.jar /usr/share/java/guava.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-util-9.1.0.v20131115.jar /usr/share/java/jetty/jetty-util.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hamcrest-core-1.3.jar /usr/share/java/hamcrest/core.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/sisu-guice-3.1.8.jar /usr/share/java/guice/google-guice.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jsch-0.1.42.jar /usr/share/java/jsch.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-io-2.4.jar /usr/share/java/commons-io.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/protobuf-java-2.5.0.jar /usr/share/java/protobuf.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/paranamer-2.3.jar /usr/share/java/paranamer/paranamer.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-logging-1.1.1.jar /usr/share/java/commons-logging.jar
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/replication/copy_tables_desc.rb
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/google-collections-1.0.jar /usr/share/java/guava.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/checkstyle-any.jar /usr/share/java/checkstyle.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/guice-3.0.jar /usr/share/java/guice/google-guice.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-yarn-common-2.2.0.jar /usr/share/java/hadoop/hadoop-yarn-common.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jackson-xc-1.8.8.jar /usr/share/java/jackson/jackson-xc.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/base64-2.3.8.jar /usr/share/java/java-base64.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-el-1.0.jar /usr/share/java/commons-el.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-yarn-server-common-2.2.0.jar /usr/share/java/hadoop/hadoop-yarn-server-common.jar
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/hbase-config.sh
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/slf4j-api-1.6.4.jar /usr/share/java/slf4j/slf4j-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-cli-1.2.jar /usr/share/java/commons-cli.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/asm-tree-5.0_BETA.jar /usr/share/java/objectweb-asm/asm-tree.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jaxb-impl-2.2.3-1.jar /usr/share/java/glassfish-jaxb/jaxb-impl.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/netty-any.jar /usr/share/java/netty.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-server-9.1.0.v20131115.jar /usr/share/java/jetty/jetty-server.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.el-SYSTEM.jar /usr/share/java/glassfish-el.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-hdfs-2.2.0.jar /usr/share/java/hadoop/hadoop-hdfs.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-codec-1.7.jar /usr/share/java/commons-codec.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-annotations-2.2.0.jar /usr/share/java/hadoop/hadoop-annotations.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-auth-2.2.0.jar /usr/share/java/hadoop/hadoop-auth.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/cglib-2.2.jar /usr/share/java/cglib.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-mapreduce-client-jobclient-2.2.0.jar /usr/share/java/hadoop/hadoop-mapreduce-client-jobclient.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jettison-1.3.1.jar /usr/share/java/jettison.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/avro-1.7.4.jar /usr/share/java/avro/avro.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/objenesis-1.0.jar /usr/share/java/objenesis/objenesis.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jackson-jaxrs-1.8.8.jar /usr/share/java/jackson/jackson-jaxrs.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/htrace-core-2.01.jar /usr/share/java/htrace/htrace-core.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jzlib-any.jar /usr/share/java/jzlib.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/slf4j-log4j12-1.6.4.jar /usr/share/java/slf4j/slf4j-log4j12.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-client-1.17.1.jar /usr/share/java/jersey/jersey-client.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-http-9.1.1.v20140108.jar /usr/share/java/jetty/jetty-http.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/org.apache.taglibs.standard.glassfish-1.2.0.v201112081803.jar /usr/share/java/jakarta-taglibs-standard.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-util-ajax-9.0.4.v20130625.jar /usr/share/java/jetty/jetty-util-ajax.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.inject-1.jar /usr/share/java/atinject.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/xz-1.4.jar /usr/share/java/xz-java.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-collections-3.2.1.jar /usr/share/java/commons-collections.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/grizzly-http-2.2.16.jar /usr/share/java/grizzly/grizzly-http.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-net-3.1.jar /usr/share/java/commons-net.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/grizzly-http-server-2.3.6.jar /usr/share/java/grizzly/grizzly-http-server.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-lang3-3.1.jar /usr/share/java/apache-commons-lang3.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/log4j-1.2.17.jar /usr/share/java/log4j.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/java-xmlbuilder-0.4.jar /usr/share/java/java-xmlbuilder.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/httpclient-4.2.5.jar /usr/share/java/httpcomponents/httpclient.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-common-2.2.0.jar /usr/share/java/../../lib/java/hadoop-common.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jsr311-api-any.jar /usr/share/java/jsr-311.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-grizzly2-1.17.1.jar /usr/share/java/jersey/jersey-grizzly2.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-yarn-server-nodemanager-2.2.0.jar /usr/share/java/hadoop/hadoop-yarn-server-nodemanager.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/zookeeper-3.4.5.jar /usr/share/java/zookeeper/zookeeper.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jaxb-api-2.2.2.jar /usr/share/java/jaxb-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-httpclient-3.1.jar /usr/share/java/jakarta-commons-httpclient.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jboss-transaction-api_1.2_spec-any.jar /usr/share/java/jboss-transaction-1.2-api/jboss-transaction-api_1.2_spec.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-mapreduce-client-shuffle-2.2.0.jar /usr/share/java/hadoop/hadoop-mapreduce-client-shuffle.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-daemon-1.0.13.jar /usr/share/java/commons-daemon.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jamon-runtime-2.3.1.jar /usr/share/java/jamon-runtime.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-servlet-9.1.0.v20131115.jar /usr/share/java/jetty/jetty-servlet.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-server-1.8.jar /usr/share/java/jersey/jersey-server.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/stax-api-1.0-2.jar /usr/share/java/bea-stax-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/annotations-1.3.9-1.jar /usr/share/java/findbugs-annotations.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/avalon-logkit-2.1.jar /usr/share/java/avalon-logkit.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/libthrift-0.9.0.jar /usr/share/java/libthrift.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/mail-1.4.3.jar /usr/share/java/javamail/javax.mail.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/zookeeper-test-any.jar /usr/share/java/zookeeper/zookeeper-test.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.servlet.jsp-api-2.3.1.jar /usr/share/java/glassfish-jsp-api/javax.servlet.jsp-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-jsp-9.1.0.v20131115.jar /usr/share/java/jetty/jetty-jsp.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/grizzly-framework-2.3.6.jar /usr/share/java/grizzly/grizzly-framework.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-io-9.1.1.v20140108.jar /usr/share/java/jetty/jetty-io.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/asm-4.0.jar /usr/share/java/objectweb-asm/asm.jar
hbase.noarch: W: non-standard-uid /var/run/hbase hbase
hbase.noarch: W: non-standard-gid /var/run/hbase hbase
hbase.noarch: W: dangling-symlink /etc/hbase/hdfs-site.xml /etc/hadoop/hdfs-site.xml
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jboss-el-api_2.2_spec-1.0.1.Final.jar /usr/share/java/jboss-el-2.2-api/jboss-el-api_2.2_spec.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/grizzly-http-servlet-2.2.16.jar /usr/share/java/grizzly/grizzly-http-servlet.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-json-1.8.jar /usr/share/java/jersey/jersey-json.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-mapreduce-client-app-2.2.0.jar /usr/share/java/hadoop/hadoop-mapreduce-client-app.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/httpcore-4.2.4.jar /usr/share/java/httpcomponents/httpcore.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/txw2-20110809.jar /usr/share/java/txw2.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jms-1.1.1.jar /usr/share/java/geronimo-jms.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-schemas-3.1.M0.jar /usr/share/java/jetty-schemas/jetty-schemas.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-grizzly2-servlet-1.17.1.jar /usr/share/java/jersey/jersey-grizzly2-servlet.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-test-framework-core-1.17.1.jar /usr/share/java/jersey/jersey-test-framework.jar
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/region_mover.rb
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jsr305-1.3.9.jar /usr/share/java/jsr-305.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/high-scale-lib-1.1.1.jar /usr/share/java/high-scale-lib/high-scale-lib.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/asm-3.jar /usr/share/java/objectweb-asm3/asm.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-webapp-9.0.4.v20130625.jar /usr/share/java/jetty/jetty-webapp.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/antlr-2.7.7.jar /usr/share/java/antlr.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-core-1.8.jar /usr/share/java/jersey/jersey-core.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-servlet-1.17.1.jar /usr/share/java/jersey/jersey-servlet.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-lang-2.6.jar /usr/share/java/apache-commons-lang.jar
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/hirb.rb
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/netty-3.6.6.Final.jar /usr/share/java/netty.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/mockito-core-any.jar /usr/share/java/mockito.jar
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/hbase-common.sh
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/aopalliance-1.0.jar /usr/share/java/aopalliance.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/xalan-2.7.1.jar /usr/share/java/xalan-j2.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/xml-apis-1.3.04.jar /usr/share/java/xml-commons-apis.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/metrics-core-3.0.1.jar /usr/share/java/metrics/metrics-core.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-configuration-1.6.jar /usr/share/java/commons-configuration.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-math3-3.2.jar /usr/share/java/commons-math3.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-security-9.1.0.v20131115.jar /usr/share/java/jetty/jetty-security.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/serializer-2.7.1.jar /usr/share/java/xalan-j2-serializer.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jackson-core-asl-1.8.8.jar /usr/share/java/jackson/jackson-core-asl.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jstl-1.1.2.jar /usr/share/java/jakarta-taglibs-core.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/snappy-java-1.0.5.jar /usr/share/java/snappy-java.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jruby-1.7.2.jar /usr/share/java/jruby.jar
hbase.noarch: W: non-standard-uid /var/cache/hbase hbase
hbase.noarch: W: non-standard-gid /var/cache/hbase hbase
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.servlet.jsp.jstl-1.2.0.v201105211821.jar /usr/share/java/jakarta-taglibs-core.jar
hbase.noarch: E: script-without-shebang /usr/share/hbase/bin/region_status.rb
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jets3t-0.9.0.jar /usr/share/java/jets3t/jets3t.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-guice-1.17.1.jar /usr/share/java/jersey/jersey-guice.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jackson-mapper-asl-1.8.8.jar /usr/share/java/jackson/jackson-mapper-asl.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/junit-4.11.jar /usr/share/java/junit.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-client-2.2.0.jar /usr/share/java/hadoop/hadoop-client.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-hdfs-2.2.0-tests.jar /usr/share/java/hadoop/hadoop-hdfs-tests.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/commons-beanutils-core-1.8.3.jar /usr/share/java/apache-commons-beanutils.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/istack-commons-runtime-2.6.1.jar /usr/share/java/istack-commons-runtime.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jboss-servlet-api_3.0_spec-1.0.1.Final.jar /usr/share/java/jboss-servlet-3.0-api/jboss-servlet-api_3.0_spec.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-yarn-api-2.2.0.jar /usr/share/java/hadoop/hadoop-yarn-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.el-any.jar /usr/share/java/glassfish-el.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/asm-util-4.0.jar /usr/share/java/objectweb-asm/asm-util.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jetty-xml-9.1.1.v20140108.jar /usr/share/java/jetty/jetty-xml.jar
hbase.noarch: W: non-standard-uid /var/log/hbase hbase
hbase.noarch: W: non-standard-gid /var/log/hbase hbase
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jersey-test-framework-grizzly2-1.17.1.jar /usr/share/java/jersey/jersey-test-framework-grizzly2.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/jsp-api-2.1.jar /usr/share/java/jboss-jsp-2.2-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-mapreduce-client-core-2.2.0.jar /usr/share/java/hadoop/hadoop-mapreduce-client-core.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-mapreduce-client-jobclient-2.2.0-tests.jar /usr/share/java/hadoop/hadoop-mapreduce-client-jobclient-tests.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/guice-servlet-3.0.jar /usr/share/java/guice/guice-servlet.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/hadoop-yarn-client-2.2.0.jar /usr/share/java/hadoop/hadoop-yarn-client.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/stax-api-1.0.1.jar /usr/share/java/bea-stax-api.jar
hbase.noarch: W: dangling-symlink /usr/share/hbase/lib/javax.servlet-api-3.1.0.jar /usr/share/java/glassfish-servlet-api.jar
hbase.noarch: W: no-manual-page-for-binary local-master-backup.sh
hbase.noarch: W: no-manual-page-for-binary hbase-daemons.sh
hbase.noarch: W: no-manual-page-for-binary graceful_stop.sh
hbase.noarch: W: no-manual-page-for-binary hbase-daemon.sh
hbase.noarch: W: no-manual-page-for-binary start-hbase.sh
hbase.noarch: W: no-manual-page-for-binary hbase-cleanup.sh
hbase.noarch: W: no-manual-page-for-binary regionservers.sh
hbase.noarch: W: no-manual-page-for-binary hbase-config.sh
hbase.noarch: W: no-manual-page-for-binary hbase-jruby
hbase.noarch: W: no-manual-page-for-binary master-backup.sh
hbase.noarch: W: no-manual-page-for-binary hbase-common.sh
hbase.noarch: W: no-manual-page-for-binary stop-hbase.sh
hbase.noarch: W: no-manual-page-for-binary local-regionservers.sh
hbase.noarch: W: no-manual-page-for-binary hbase
hbase.noarch: W: no-manual-page-for-binary rolling-restart.sh
hbase.noarch: W: no-manual-page-for-binary zookeepers.sh
hbase-tests.noarch: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
hbase-tests.noarch: W: no-documentation
hbase.src: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
hbase.src:297: W: libdir-macro-in-noarch-package native %{_libdir}/%{name}
4 packages and 0 specfiles checked; 6 errors, 165 warnings.




Requires
--------
hbase (rpmlib, GLIBC filtered):
    /bin/bash
    /bin/sh
    /usr/bin/env
    apache-commons-lang3
    bytelist
    config(hbase)
    glassfish-el-api
    invokebinder
    jansi
    java
    jcodings
    jline
    jnr-constants
    jnr-ffi
    jnr-posix
    joda-time
    joni
    jpackage-utils
    mvn(com.codahale.metrics:metrics-core)
    mvn(com.github.stephenc.high-scale-lib:high-scale-lib)
    mvn(com.google.code.findbugs:annotations)
    mvn(com.google.guava:guava)
    mvn(com.google.protobuf:protobuf-java)
    mvn(com.sun.jersey:jersey-core)
    mvn(com.sun.jersey:jersey-json)
    mvn(com.sun.jersey:jersey-server)
    mvn(commons-cli:commons-cli)
    mvn(commons-codec:commons-codec)
    mvn(commons-collections:commons-collections)
    mvn(commons-httpclient:commons-httpclient)
    mvn(commons-io:commons-io)
    mvn(commons-lang:commons-lang)
    mvn(commons-logging:commons-logging)
    mvn(io.netty:netty:3.6.6.Final)
    mvn(javax.servlet.jsp:jsp-api)
    mvn(javax.xml.bind:jaxb-api)
    mvn(junit:junit)
    mvn(log4j:log4j)
    mvn(org.apache.commons:commons-math3)
    mvn(org.apache.hadoop:hadoop-annotations)
    mvn(org.apache.hadoop:hadoop-auth)
    mvn(org.apache.hadoop:hadoop-client)
    mvn(org.apache.hadoop:hadoop-common)
    mvn(org.apache.hadoop:hadoop-hdfs)
    mvn(org.apache.hadoop:hadoop-hdfs::tests:)
    mvn(org.apache.hadoop:hadoop-mapreduce-client-core)
    mvn(org.apache.hadoop:hadoop-mapreduce-client-jobclient::tests:)
    mvn(org.apache.thrift:libthrift)
    mvn(org.apache.zookeeper:zookeeper)
    mvn(org.cloudera.htrace:htrace-core)
    mvn(org.codehaus.jackson:jackson-core-asl)
    mvn(org.codehaus.jackson:jackson-jaxrs)
    mvn(org.codehaus.jackson:jackson-mapper-asl)
    mvn(org.eclipse.jetty:jetty-jsp)
    mvn(org.eclipse.jetty:jetty-security)
    mvn(org.eclipse.jetty:jetty-server)
    mvn(org.eclipse.jetty:jetty-servlet)
    mvn(org.eclipse.jetty:jetty-util)
    mvn(org.glassfish.web:javax.servlet.jsp)
    mvn(org.jamon:jamon-runtime)
    mvn(org.jruby:jruby)
    mvn(org.slf4j:slf4j-api)
    mvn(stax:stax-api)
    objectweb-asm
    systemd

hbase-tests (rpmlib, GLIBC filtered):
    hadoop-tests
    hbase
    java
    jpackage-utils
    mvn(com.google.code.findbugs:annotations)
    mvn(junit:junit)
    mvn(log4j:log4j)
    mvn(org.apache.hadoop:hadoop-annotations)
    mvn(org.apache.hadoop:hadoop-auth)
    mvn(org.apache.hadoop:hadoop-client)
    mvn(org.apache.hadoop:hadoop-common)
    mvn(org.apache.hadoop:hadoop-hdfs)
    mvn(org.apache.hadoop:hadoop-hdfs::tests:)
    mvn(org.apache.hadoop:hadoop-mapreduce-client-core)
    mvn(org.apache.hadoop:hadoop-mapreduce-client-jobclient)
    mvn(org.apache.hadoop:hadoop-minicluster)
    mvn(org.apache.hbase:hbase-client)
    mvn(org.apache.hbase:hbase-common)
    mvn(org.apache.hbase:hbase-hadoop-compat)
    mvn(org.apache.hbase:hbase-hadoop2-compat)
    mvn(org.apache.hbase:hbase-protocol)
    mvn(org.apache.hbase:hbase-server)
    mvn(org.slf4j:slf4j-log4j12)

hbase-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
hbase:
    config(hbase)
    hbase
    mvn(org.apache.hbase:hbase)
    mvn(org.apache.hbase:hbase-assembly)
    mvn(org.apache.hbase:hbase-assembly:pom:)
    mvn(org.apache.hbase:hbase-client)
    mvn(org.apache.hbase:hbase-common)
    mvn(org.apache.hbase:hbase-examples)
    mvn(org.apache.hbase:hbase-hadoop-compat)
    mvn(org.apache.hbase:hbase-hadoop2-compat)
    mvn(org.apache.hbase:hbase-it)
    mvn(org.apache.hbase:hbase-prefix-tree)
    mvn(org.apache.hbase:hbase-protocol)
    mvn(org.apache.hbase:hbase-server)
    mvn(org.apache.hbase:hbase-shell)
    mvn(org.apache.hbase:hbase-thrift)
    mvn(org.apache.hbase:hbase:pom:)

hbase-tests:
    hbase-tests
    mvn(org.apache.hbase:hbase-client::tests:)
    mvn(org.apache.hbase:hbase-common::tests:)
    mvn(org.apache.hbase:hbase-examples::tests:)
    mvn(org.apache.hbase:hbase-hadoop-compat::tests:)
    mvn(org.apache.hbase:hbase-hadoop2-compat::tests:)
    mvn(org.apache.hbase:hbase-it::tests:)
    mvn(org.apache.hbase:hbase-prefix-tree::tests:)
    mvn(org.apache.hbase:hbase-protocol::tests:)
    mvn(org.apache.hbase:hbase-server::tests:)
    mvn(org.apache.hbase:hbase-shell::tests:)
    mvn(org.apache.hbase:hbase-testing-util)
    mvn(org.apache.hbase:hbase-testing-util::tests:)
    mvn(org.apache.hbase:hbase-thrift::tests:)

hbase-javadoc:
    hbase-javadoc



Source checksums
----------------
https://github.com/apache/hbase/archive/3bfbff994e9ece179bb5ac747978677a911790c9/hbase-0.96.1.1-3bfbff9.tar.gz :
  CHECKSUM(SHA256) this package     : ef9a79a62df6c40926c1342b3c2d800f8ef71a21427c4e688df06d6afa901d65
  CHECKSUM(SHA256) upstream package : ef9a79a62df6c40926c1342b3c2d800f8ef71a21427c4e688df06d6afa901d65


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1045556 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


check is disabled

Comment 11 Christopher Meng 2014-01-26 00:05:47 UTC
Tests should always be enabled if possible. If tests fail at Koji, then it's necessary to disable them. Otherwise, shouldn't be disabled.

Comment 12 Haïkel Guémar 2014-01-26 09:43:14 UTC
According guidelines:
"If the source code of the package provides a test suite, it *should* be executed in the %check section, whenever it is *practical* to do so."

First, enabling tests is not mandatory, it's strongly advised to execute them.
Then, the guideline insists on the fact it is practical to do so, so it's up
to the packager or the reviewer judgement.

Since, the execution of the tests suite takes up to 20 minutes, i personnally
consider this to be a legit argument no to enable them.
My personal choice would have been to enable them by default, and allowing 
people to quickly rebuild it if requires.
As a reviewer, i can only make suggestions to the packager on that point:
"consider using a build conditional so one could easily enable or better disable test suite execution".

My duty as a reviewer is not to enforce my POV, just the guidelines and ensure
high quality packaging and that's the case here.

That's why i approved this package, and i trust my fellow packager to do the
right choice on that matter.

Comment 13 Michael S. 2014-01-26 10:45:03 UTC
20 minutes is indeed a lot. Couldn't at least a subset be enabled to catch the most egregious errors ?

Comment 14 Ralf Corsepius 2014-01-26 11:38:14 UTC
(In reply to Haïkel Guémar from comment #12)
> According guidelines:
> "If the source code of the package provides a test suite, it *should* be
> executed in the %check section, whenever it is *practical* to do so."
> 
> First, enabling tests is not mandatory, it's strongly advised to execute
> them.
> Then, the guideline insists on the fact it is practical to do so, so it's up
> to the packager or the reviewer judgement.

Well, the FPG's formulation isn't aiming at "testsuite execution speed", it is aiming at packages whose testsuite's complexity would overly complicate packaging a package. In other words it's meant to prevent case where sloppily written crap-ware would not pass reviews, while packages with very evolved and complex testsuites would not pass reviews.

That said,
* 20 mins of testsuite execution time is not extraordinary.

* Nothing prevents a packager to add --with/--without conditionals (with a default to execise the testsuite) to an rpm-spec to speed up local testbuilding.

Comment 15 Haïkel Guémar 2014-01-26 12:07:09 UTC
Hi Ralf, i do trust your judgment (all the more as you're part of the FPC), but i'll wait Robert's opinion on that matter.
May i suggest that we request a better wording for this guideline as we regularly run into interpretation issues ?

Since it's a trivial fix, i don't think it will be a problem to add a build conditional to disable test suite execution ifor local builds.

Comment 16 Robert Rati 2014-01-27 12:39:14 UTC
I disabled the tests for 2 reasons. 1) They took quite some time to run through, and 2) they were unstable.  In my local testing, the suite never ran through to completion and the failure case would eventually result in the build hanging for forever as far as I could tell.  I know I waited upwards of 30 minutes in one of the hang cases and it never timed out or completed.  The tests also seemed to impact each other even previous ones passed.  When running the suite locally tests would start failing with odd errors when all the tests were run together, but if the test was run separately or even if the module was run separately then everything would pass.  It may be possible to come up with a way to run the tests that would be less unstable, but the test suite did not give me confidence it could be run consistently with useful results.

Comment 17 Haïkel Guémar 2014-01-27 12:43:46 UTC
Since hbase tests are unstable, i think that no one will require you to enable them. Please consider adding a build conditional but i won't make it a blocker.

So, i confirm that the review is approved, please continue with scm request.

Comment 18 Robert Rati 2014-01-27 13:52:34 UTC
New Package SCM Request
=======================
Package Name: hbase
Short Description: The Apache Hadoop database
Owners: rrati
Branches: 
InitialCC:

Comment 19 Gwyn Ciesla 2014-01-27 13:58:52 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.